diff --git a/lib/hive/dependency_check.rb b/lib/hive/dependency_check.rb
new file mode 100644
index 00000000..0b063c6f
--- /dev/null
+++ b/lib/hive/dependency_check.rb
@@ -0,0 +1,27 @@
+module Hive
+  module DependencyCheck
+    TOOLS = {
+      "git" => "Install Git with your operating system's package manager.",
+      "bash" => "Install Bash with your operating system's package manager.",
+      "claude" => "Install the Claude Code CLI from its official distribution.",
+      "gh" => "Install GitHub CLI from https://cli.github.com/.",
+      "jq" => "Install jq with your operating system's package manager."
+    }.freeze
+    module_function
+
+    def call(path: ENV.fetch("PATH", ""))
+      TOOLS.map do |name, hint|
+        executable = resolve(name, path)
+        { name: name, status: executable ? :available : :missing, path: executable, hint: executable ? nil : hint }
+      end
+    end
+
+    def resolve(name, path)
+      path.split(File::PATH_SEPARATOR).each do |directory|
+        candidate = File.join(directory, name)
+        return candidate if File.file?(candidate) && File.executable?(candidate)
+      end
+      nil
+    end
+  end
+end
diff --git a/lib/hive/install/channel.rb b/lib/hive/install/channel.rb
new file mode 100644
index 00000000..c8e753ca
--- /dev/null
+++ b/lib/hive/install/channel.rb
@@ -0,0 +1,121 @@
+require "open3"
+require "digest"
+require "hive/command_name"
+require "hive/install/receipt"
+
+module Hive
+  module Install
+    class Channel
+      def initialize(receipt, runner: Open3.method(:capture3), resolver: Hive::CommandName.method(:resolve))
+        @receipt = Hive::Install::Receipt.validate!(receipt)
+        @runner = runner
+        @resolver = resolver
+      end
+
+      def verify_ownership!
+        case @receipt["channel"]
+        when "homebrew"
+          verify_homebrew_ownership!
+        when "aur"
+          verify_aur_ownership!
+        when "shell"
+          verify_shell_ownership!
+        end
+        true
+      end
+
+      def update
+        case @receipt["channel"]
+        when "homebrew"
+          execute("brew", "upgrade", @receipt["package"])
+        when "aur"
+          helper = aur_helper!
+          execute(helper, "-S", "--needed", @receipt["package"])
+        when "shell"
+          installer = @receipt["installer"]
+          raise Hive::ConfigError, Hive::Install::Receipt.recovery("shell installer path is absent") unless installer
+
+          execute(installer, "--update")
+        end
+      end
+
+      def uninstall
+        case @receipt["channel"]
+        when "homebrew"
+          execute("brew", "uninstall", @receipt["package"])
+        when "aur"
+          execute(aur_helper!, "-Rns", "--noconfirm", @receipt["package"])
+        when "shell"
+          uninstaller = @receipt["uninstaller"]
+          raise Hive::ConfigError, Hive::Install::Receipt.recovery("shell uninstaller path is absent") unless uninstaller
+
+          execute(uninstaller, "--yes")
+        end
+      end
+
+      private
+
+      def verify_homebrew_ownership!
+        prefix = execute_capture("brew", "--prefix", @receipt["package"]).strip
+        expected = File.join(prefix, "bin", "hv")
+        return if same_file_or_path?(@receipt["executable"], expected)
+
+        raise Hive::ConfigError,
+              Hive::Install::Receipt.recovery("Homebrew receipt executable does not belong to #{@receipt['package']}")
+      end
+
+      def verify_aur_ownership!
+        owner = execute_capture("pacman", "-Qqo", @receipt["executable"]).strip
+        return if owner == @receipt["package"]
+
+        raise Hive::ConfigError,
+              Hive::Install::Receipt.recovery("AUR receipt executable is owned by #{owner.inspect}")
+      end
+
+      def verify_shell_ownership!
+        {
+          @receipt["executable"] => @receipt["executable_sha256"],
+          @receipt["installer"] => @receipt["installer_sha256"],
+          @receipt["uninstaller"] => @receipt["uninstaller_sha256"]
+        }.each do |path, expected|
+          unless File.file?(path) && !File.symlink?(path) && Digest::SHA256.file(path).hexdigest == expected
+            raise Hive::ConfigError, Hive::Install::Receipt.recovery("shell-managed file failed ownership verification: #{path}")
+          end
+        end
+      end
+
+      def same_file_or_path?(left, right)
+        return false unless File.file?(left) && File.file?(right)
+
+        File.identical?(left, right)
+      rescue Errno::ENOENT
+        false
+      end
+
+      def aur_helper!
+        helper = %w[paru yay].filter_map { |name| @resolver.call(name) }.first
+        raise Hive::ConfigError, "no supported AUR helper found (install paru or yay)" unless helper
+
+        helper
+      end
+
+      def execute_capture(*command)
+        out, err, status = @runner.call(*command)
+        return out if status.success?
+
+        raise Hive::Error, "#{command.join(' ')} failed: #{err.strip}"
+      rescue Errno::ENOENT
+        raise Hive::ConfigError, "owning package tool #{command.first} is unavailable"
+      end
+
+      def execute(*command)
+        _out, err, status = @runner.call(*command)
+        return true if status.success?
+
+        raise Hive::Error, "#{command.join(' ')} failed: #{err.strip}"
+      rescue Errno::ENOENT
+        raise Hive::ConfigError, "owning package tool #{command.first} is unavailable"
+      end
+    end
+  end
+end
diff --git a/lib/hive/install/receipt.rb b/lib/hive/install/receipt.rb
new file mode 100644
index 00000000..0a716d7d
--- /dev/null
+++ b/lib/hive/install/receipt.rb
@@ -0,0 +1,106 @@
+require "fileutils"
+require "yaml"
+require "hive/paths"
+
+module Hive
+  module Install
+    module Receipt
+      CHANNELS = %w[homebrew aur shell].freeze
+      REQUIRED = %w[schema_version channel package command_name executable release_source managed_files].freeze
+      SHELL_REQUIRED = %w[
+        executable_sha256 installer installer_sha256 uninstaller uninstaller_sha256
+      ].freeze
+      module_function
+
+      def load(path = Hive::Paths.receipt_file)
+        raise Hive::ConfigError, recovery("install receipt is missing at #{path}") unless File.file?(path)
+
+        data = YAML.safe_load_file(path)
+        validate!(data)
+      rescue Psych::Exception => e
+        raise Hive::ConfigError, recovery("install receipt is malformed: #{e.message}")
+      end
+
+      def write!(path: Hive::Paths.receipt_file, data:)
+        receipt = { "schema_version" => 1 }.merge(data)
+        validate!(receipt)
+        FileUtils.mkdir_p(File.dirname(path))
+        temporary = "#{path}.tmp-#{Process.pid}"
+        File.write(temporary, receipt.to_yaml, mode: "w", perm: 0o600)
+        File.chmod(0o600, temporary)
+        File.rename(temporary, path)
+        receipt
+      ensure
+        FileUtils.rm_f(temporary) if defined?(temporary) && temporary
+      end
+
+      def validate!(data)
+        raise Hive::ConfigError, recovery("install receipt must be a mapping") unless data.is_a?(Hash)
+        unless data["schema_version"] == 1
+          raise Hive::ConfigError, recovery("unsupported install receipt schema")
+        end
+        unless CHANNELS.include?(data["channel"])
+          raise Hive::ConfigError, recovery("invalid install receipt channel #{data['channel'].inspect}")
+        end
+        missing = REQUIRED.reject { |key| present_field?(data[key]) }
+        raise Hive::ConfigError, recovery("install receipt is missing #{missing.join(', ')}") unless missing.empty?
+        unless %w[hive hv].include?(data["command_name"])
+          raise Hive::ConfigError, recovery("invalid install receipt command name")
+        end
+        unless File.basename(data["executable"]) == "hv"
+          raise Hive::ConfigError, recovery("install receipt executable must be the stable hv command")
+        end
+
+        validate_managed_files!(data)
+        validate_shell!(data) if data["channel"] == "shell"
+
+        data
+      end
+
+      def present_field?(value)
+        (value.is_a?(String) && !value.empty?) || (value.is_a?(Array) && !value.empty?) || value == 1
+      end
+      private_class_method :present_field?
+
+      def validate_managed_files!(data)
+        paths = data["managed_files"]
+        unless paths.is_a?(Array) && paths.all? { |path| absolute_path?(path) } && paths.uniq == paths
+          raise Hive::ConfigError, recovery("install receipt managed_files must be unique absolute paths")
+        end
+        return if absolute_path?(data["executable"]) && paths.include?(data["executable"])
+
+        raise Hive::ConfigError, recovery("install receipt does not bind its executable to managed_files")
+      end
+      private_class_method :validate_managed_files!
+
+      def validate_shell!(data)
+        missing = SHELL_REQUIRED.reject { |key| data[key].is_a?(String) && !data[key].empty? }
+        raise Hive::ConfigError, recovery("shell receipt is missing #{missing.join(', ')}") unless missing.empty?
+
+        %w[executable_sha256 installer_sha256 uninstaller_sha256].each do |key|
+          next if data[key].match?(/\A[a-f0-9]{64}\z/)
+
+          raise Hive::ConfigError, recovery("shell receipt has invalid #{key}")
+        end
+        { "installer" => "install.sh", "uninstaller" => "uninstall-shell.sh" }.each do |key, basename|
+          path = data[key]
+          unless absolute_path?(path) && File.basename(path) == basename && data["managed_files"].include?(path)
+            raise Hive::ConfigError, recovery("shell receipt has invalid #{key} ownership")
+          end
+        end
+      end
+      private_class_method :validate_shell!
+
+      def absolute_path?(path)
+        path.is_a?(String) && !path.empty? && File.absolute_path(path) == path
+      rescue ArgumentError
+        false
+      end
+      private_class_method :absolute_path?
+
+      def recovery(message)
+        "#{message}; reinstall Hive through the original channel to repair ownership"
+      end
+    end
+  end
+end
diff --git a/lib/hive/paths.rb b/lib/hive/paths.rb
new file mode 100644
index 00000000..a668f7c3
--- /dev/null
+++ b/lib/hive/paths.rb
@@ -0,0 +1,72 @@
+module Hive
+  module Paths
+    module_function
+
+    def config_dir
+      File.join(xdg_root("XDG_CONFIG_HOME", ".config"), "hive")
+    end
+
+    def data_dir
+      File.join(xdg_root("XDG_DATA_HOME", ".local/share"), "hive")
+    end
+
+    def state_dir
+      service_state = ENV["HIVE_STATE_DIR"]
+      return File.expand_path(service_state) if service_state && !service_state.empty?
+
+      File.join(xdg_root("XDG_STATE_HOME", ".local/state"), "hive")
+    end
+
+    def cache_dir
+      File.join(xdg_root("XDG_CACHE_HOME", ".cache"), "hive")
+    end
+
+    def runtime_dir
+      root = ENV["XDG_RUNTIME_DIR"]
+      root && !root.empty? ? File.join(root, "hive") : File.join(state_dir, "run")
+    end
+
+    def bin_dir
+      ENV.fetch("HIVE_BIN_DIR") { File.join(home, ".local", "bin") }
+    end
+
+    def config_file
+      File.join(config_dir, "config.yml")
+    end
+
+    def receipt_file
+      ENV.fetch("HIVE_INSTALL_RECEIPT") { File.join(data_dir, "install-receipt.yml") }
+    end
+
+    def releases_dir
+      File.join(data_dir, "releases")
+    end
+
+    def release_dir(version = Hive::VERSION)
+      File.join(releases_dir, version)
+    end
+
+    def resource_root
+      override = ENV["HIVE_RESOURCE_ROOT"]
+      return File.expand_path(override) if override && !override.empty?
+
+      File.expand_path("../..", __dir__)
+    end
+
+    def resource(*parts)
+      File.join(resource_root, *parts)
+    end
+
+    def home
+      File.expand_path(ENV.fetch("HOME"))
+    end
+
+    def xdg_root(name, fallback)
+      configured = ENV[name]
+      return File.expand_path(configured) if configured && !configured.empty?
+
+      File.join(home, fallback)
+    end
+    private_class_method :xdg_root
+  end
+end
diff --git a/lib/hive/service.rb b/lib/hive/service.rb
new file mode 100644
index 00000000..8fce3b7c
--- /dev/null
+++ b/lib/hive/service.rb
@@ -0,0 +1,24 @@
+require "rbconfig"
+require "hive/paths"
+require "hive/command_name"
+require "hive/services/launchd"
+require "hive/services/systemd_user"
+
+module Hive
+  module Service
+    module_function
+
+    def current(executable: nil, platform: nil)
+      executable ||= Hive::CommandName.stable_executable
+      platform ||= ENV["HIVE_SERVICE_PLATFORM"] || RbConfig::CONFIG["host_os"]
+      case platform
+      when /darwin/
+        Hive::Services::Launchd.new(executable: executable)
+      when /linux/
+        Hive::Services::SystemdUser.new(executable: executable)
+      else
+        raise Hive::ConfigError, "unsupported user service manager for #{platform}"
+      end
+    end
+  end
+end
diff --git a/lib/hive/services/launchd.rb b/lib/hive/services/launchd.rb
new file mode 100644
index 00000000..bbf8320e
--- /dev/null
+++ b/lib/hive/services/launchd.rb
@@ -0,0 +1,79 @@
+require "cgi"
+require "fileutils"
+require "open3"
+require "hive/paths"
+
+module Hive
+  module Services
+    class Launchd
+      LABEL = "org.hive.daemon".freeze
+
+      def initialize(executable:, home: Dir.home, runner: Open3.method(:capture3), uid: Process.uid)
+        @executable = File.expand_path(executable)
+        @home = home
+        @runner = runner
+        @uid = uid
+      end
+
+      def definition_path
+        File.join(@home, "Library", "LaunchAgents", "#{LABEL}.plist")
+      end
+
+      def register
+        FileUtils.mkdir_p(File.dirname(definition_path))
+        content = File.read(Hive::Paths.resource("assets", "services", "launchd.plist"))
+                      .gsub("@EXECUTABLE@", CGI.escapeHTML(@executable))
+                      .gsub("@STATE_DIR@", CGI.escapeHTML(Hive::Paths.state_dir))
+        write_atomic(definition_path, content)
+        :registered_stopped
+      end
+
+      def start
+        execute("launchctl", "bootstrap", domain, definition_path, allow_failure: true)
+        execute("launchctl", "kickstart", "#{domain}/#{LABEL}")
+        :running
+      end
+
+      def stop
+        execute("launchctl", "bootout", "#{domain}/#{LABEL}", allow_failure: true)
+        :registered_stopped
+      end
+
+      def status
+        _out, _err, result = @runner.call("launchctl", "print", "#{domain}/#{LABEL}")
+        result.success? ? :running : :registered_stopped
+      end
+
+      def unregister
+        return :unregistered unless File.exist?(definition_path) || File.symlink?(definition_path)
+
+        stop
+        FileUtils.rm_f(definition_path)
+        :unregistered
+      end
+
+      private
+
+      def domain
+        "gui/#{@uid}"
+      end
+
+      def write_atomic(path, content)
+        temporary = "#{path}.tmp-#{Process.pid}"
+        File.write(temporary, content)
+        File.rename(temporary, path)
+      ensure
+        FileUtils.rm_f(temporary) if defined?(temporary) && temporary
+      end
+
+      def execute(*command, allow_failure: false)
+        _out, err, status = @runner.call(*command)
+        return if status.success? || allow_failure
+
+        raise Hive::Error, "#{command.join(' ')} failed: #{err.strip}"
+      rescue Errno::ENOENT
+        raise Hive::ConfigError, "launchd is unavailable"
+      end
+    end
+  end
+end
diff --git a/lib/hive/services/systemd_user.rb b/lib/hive/services/systemd_user.rb
new file mode 100644
index 00000000..ed28daa0
--- /dev/null
+++ b/lib/hive/services/systemd_user.rb
@@ -0,0 +1,97 @@
+require "fileutils"
+require "open3"
+require "shellwords"
+require "hive/paths"
+
+module Hive
+  module Services
+    class SystemdUser
+      UNIT = "hive.service".freeze
+
+      def initialize(executable:, config_home: ENV["XDG_CONFIG_HOME"], runner: Open3.method(:capture3))
+        @executable = File.expand_path(executable)
+        @config_home = config_home && !config_home.empty? ? config_home : File.join(Dir.home, ".config")
+        @runner = runner
+      end
+
+      def definition_path
+        File.join(@config_home, "systemd", "user", UNIT)
+      end
+
+      def register
+        previous = File.binread(definition_path) if File.file?(definition_path) && !File.symlink?(definition_path)
+        write_definition
+        execute("systemctl", "--user", "daemon-reload")
+        :registered_stopped
+      rescue Hive::Error
+        restore_definition(previous)
+        execute("systemctl", "--user", "daemon-reload", allow_failure: true)
+        raise
+      end
+
+      def start
+        execute("systemctl", "--user", "enable", "--now", UNIT)
+        :running
+      end
+
+      def stop
+        execute("systemctl", "--user", "disable", "--now", UNIT, allow_failure: true)
+        :registered_stopped
+      end
+
+      def status
+        _out, _err, result = @runner.call("systemctl", "--user", "is-active", "--quiet", UNIT)
+        result.success? ? :running : :registered_stopped
+      end
+
+      def unregister
+        return :unregistered unless File.exist?(definition_path) || File.symlink?(definition_path)
+
+        stop
+        previous = File.binread(definition_path) if File.file?(definition_path) && !File.symlink?(definition_path)
+        FileUtils.rm_f(definition_path)
+        execute("systemctl", "--user", "daemon-reload")
+        :unregistered
+      rescue Hive::Error
+        restore_definition(previous) if defined?(previous)
+        execute("systemctl", "--user", "daemon-reload", allow_failure: true)
+        raise
+      end
+
+      private
+
+      def write_definition
+        FileUtils.mkdir_p(File.dirname(definition_path))
+        content = File.read(Hive::Paths.resource("assets", "services", "hive.service"))
+                      .gsub("@EXECUTABLE@", Shellwords.escape(@executable))
+                      .gsub("@STATE_DIR@", Shellwords.escape(Hive::Paths.state_dir))
+        write_atomic(definition_path, content)
+      end
+
+      def write_atomic(path, content)
+        temporary = "#{path}.tmp-#{Process.pid}"
+        File.write(temporary, content)
+        File.rename(temporary, path)
+      ensure
+        FileUtils.rm_f(temporary) if defined?(temporary) && temporary
+      end
+
+      def restore_definition(previous)
+        if previous
+          write_atomic(definition_path, previous)
+        else
+          FileUtils.rm_f(definition_path)
+        end
+      end
+
+      def execute(*command, allow_failure: false)
+        _out, err, status = @runner.call(*command)
+        return if status.success? || allow_failure
+
+        raise Hive::Error, "#{command.join(' ')} failed: #{err.strip}"
+      rescue Errno::ENOENT
+        raise Hive::ConfigError, "systemd user service manager is unavailable"
+      end
+    end
+  end
+end
diff --git a/lib/hive/version.rb b/lib/hive/version.rb
new file mode 100644
index 00000000..a89e72fa
--- /dev/null
+++ b/lib/hive/version.rb
@@ -0,0 +1,3 @@
+module Hive
+  VERSION = "0.1.0".freeze unless const_defined?(:VERSION)
+end
diff --git a/packaging/aur/.SRCINFO b/packaging/aur/.SRCINFO
new file mode 100644
index 00000000..48837e93
--- /dev/null
+++ b/packaging/aur/.SRCINFO
@@ -0,0 +1,14 @@
+pkgbase = hive-bin
+	pkgdesc = Agent-driven software delivery pipeline (prebuilt)
+	pkgver = 0.1.0
+	pkgrel = 1
+	url = https://github.com/example/hive
+	arch = x86_64
+	license = MIT
+	depends = glibc
+	provides = hive
+	install = hive-bin.install
+	source_x86_64 = hive-0.1.0-linux-x86_64.tar.gz::https://github.com/example/hive/releases/download/v0.1.0/hive-0.1.0-linux-x86_64.tar.gz
+	sha256sums_x86_64 = 0000000000000000000000000000000000000000000000000000000000000000
+
+pkgname = hive-bin
diff --git a/packaging/aur/hive-bin.install b/packaging/aur/hive-bin.install
new file mode 100644
index 00000000..a5ae52e4
--- /dev/null
+++ b/packaging/aur/hive-bin.install
@@ -0,0 +1,32 @@
+post_install() {
+  if [ -e /usr/bin/hive ] || [ -L /usr/bin/hive ]; then
+    sed -i 's/^command_name: hive$/command_name: hv/' /usr/share/hive/install-receipt.yml
+    echo "Hive installed as hv; preserving existing hive command."
+  elif command -v hive >/dev/null 2>&1; then
+    echo "Hive installed as hv; preserving existing hive command."
+  else
+    ln -s /usr/bin/hv /usr/bin/hive
+    sed -i 's/^command_name: hv$/command_name: hive/' /usr/share/hive/install-receipt.yml
+  fi
+  for tool in git bash claude gh jq; do
+    command -v "$tool" >/dev/null 2>&1 ||
+      echo "Optional Hive dependency missing: $tool. Install it separately."
+  done
+  echo "Run hive init (or hv init) to register the user daemon; package installation does not start it."
+}
+
+pre_upgrade() {
+  if [ -L /usr/bin/hive ] && [ "$(readlink /usr/bin/hive)" = "/usr/bin/hv" ]; then
+    rm -f /usr/bin/hive
+  fi
+}
+
+post_upgrade() {
+  post_install
+}
+
+pre_remove() {
+  if [ -L /usr/bin/hive ] && [ "$(readlink /usr/bin/hive)" = "/usr/bin/hv" ]; then
+    rm -f /usr/bin/hive
+  fi
+}
diff --git a/packaging/tebako/versions.env b/packaging/tebako/versions.env
new file mode 100644
index 00000000..e8d67a8d
--- /dev/null
+++ b/packaging/tebako/versions.env
@@ -0,0 +1,2 @@
+TEBAKO_VERSION=0.12.0
+RUBY_VERSION=3.4.1
diff --git a/scripts/build-release b/scripts/build-release
new file mode 100755
index 00000000..399b9372
--- /dev/null
+++ b/scripts/build-release
@@ -0,0 +1,52 @@
+#!/usr/bin/env bash
+set -euo pipefail
+
+root="$(cd "$(dirname "${BASH_SOURCE[0]}")/.." && pwd)"
+version=""
+target=""
+output_dir="${root}/build"
+
+while (($#)); do
+  case "$1" in
+    --version) version="${2:-}"; shift 2 ;;
+    --target) target="${2:-}"; shift 2 ;;
+    --output-dir) output_dir="${2:-}"; shift 2 ;;
+    *) echo "build-release: unknown argument: $1" >&2; exit 64 ;;
+  esac
+done
+
+if [[ ! "${version}" =~ ^[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
+  echo "build-release: --version must be strict semver (without v)" >&2
+  exit 64
+fi
+
+if [[ -z "${target}" ]]; then
+  case "$(uname -s)-$(uname -m)" in
+    Darwin-arm64) target="darwin-arm64" ;;
+    Linux-x86_64) target="linux-x86_64" ;;
+    *) echo "build-release: unsupported build host" >&2; exit 64 ;;
+  esac
+fi
+
+case "${target}" in
+  darwin-arm64|linux-x86_64) ;;
+  *) echo "build-release: unsupported target ${target}" >&2; exit 64 ;;
+esac
+
+source "${root}/packaging/tebako/versions.env"
+packager="${HIVE_PACKAGER:-tebako}"
+command -v "${packager}" >/dev/null 2>&1 || {
+  echo "build-release: ${packager} is unavailable" >&2
+  exit 69
+}
+
+mkdir -p "${output_dir}"
+output="${output_dir}/hive-${target}"
+"${packager}" press \
+  "--root=${root}" \
+  "--entry-point=bin/hive" \
+  "--output=${output}" \
+  "--Ruby=${RUBY_VERSION}"
+chmod 0755 "${output}"
+"${output}" --version | grep -Fx "${version}" >/dev/null
+echo "${output}"
